Bug Hunting Session
Bug 82184 - Improve installation process for non en-US locales
Summary: Improve installation process for non en-US locales
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Installation (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: medium major
Assignee: Not Assigned
URL:
Whiteboard: target:6.3.0 target:6.2.4
Keywords:
Depends on:
Blocks: Installer
  Show dependency treegraph
 
Reported: 2014-08-05 10:46 UTC by Michael Bauer
Modified: 2019-04-30 00:45 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Bauer 2014-08-05 10:46:11 UTC
The installation process is currently extremely unhelpful for users who a) do not want LO in en-US and/or 2) who do not have the luxury of a localized OS and/or 3) who want to choose a LO UI language other than their OS.

At the moment, this process is unintuitive at the stage where the user selects what seems like a locale specific download file (but which does not automatically result in that locale being installed as default depending on the setup of their system).

It is then similarly unhelpful when using the default installer (which is really what everyone downloads anyway) because the user has to *know* to choose Custom Installation to select the UI language they wanted. Most people don't and give up in frustration when the language they actually picked during download a) does not show up automatically and b) cannot even be selected manually in the Settings afterwards.

This causes a lot of aggro on behalf of new/low tech users and creates a lot of unnecessary IT support requests for people trying to promote LO.

2 possible solutions:
A) Do away with the pre-selection during download and the "hidden" selection of the UI language in the installation process which hardly anyone can find. Instead, make all languages selectable after installation by going to the Settings. This may require not shipping proofing tools with the default installer but downloading when a user selects a language other than en-US.

B) Change the existing process so that:
- if user downloads specific locale, desired locale should be installed and set by default (if this is impossible, then remove the misleading 'selection' from the download pages)
- if user downloads default multi-locale build, whether your choose custom or default, user should be asked a simple question 'what language do you want for your UI?'
- UI locales and proofing locales should be sorted alphabetically (those using non-Latin scripts to be sorted by romanization i.e. मराठी  > listed as if written Marathi; 日本語 > listed as if written Nihongo.
Comment 1 Adolfo Jayme 2014-08-05 10:57:53 UTC
This bug is related to the website, as such it should go to Redmine.
Comment 2 Michael Bauer 2014-08-05 11:03:26 UTC
(In reply to comment #1)
> This bug is related to the website, as such it should go to Redmine.

No this is not primarily about the website. It is primarily about the LO *installer* and only tangentially involves the website.
Comment 3 Cor Nouws 2014-08-05 11:14:06 UTC
(didn't we already have a bug for this?)
Comment 4 Michael Bauer 2014-08-05 11:38:55 UTC
I can't find one, even amongst closed bugs and Sveinn also couldn't find one.
Comment 5 Mikeyy - L10n HR 2014-08-05 12:03:11 UTC
My suggestion:

First screen from installer should be.

"Please choose your LibreOffice language:"

And then dropdown menu with localised language names sorted in alphabetical order.

"
Deutsch
English (UK)
English (US)
Francais
Hrvatski
"

Or english - locale

"
Croatian - Hrvatski
English (UK)
English (US)
French - Francais
German - Deutsch
"

And default selection (already selected) should be sistem (OS) language.

From there everything should be in selected language, from installation to LibreOffice UI and localization options.
Comment 6 Christian Lohmaier 2014-08-05 12:58:43 UTC
modifying the download as it happens is a no-go. Virus scanners would go nuts, you could not provide checksums/verification, digital signatures would be invalidated.

Listing languages to pick will also present the user with an English "greeting"/instructions to pick a language, so only helps partially, as a "shortcut" to the customized installation. So it could just tell to pick "custom install" and select the language(s) to install" right away without /that/ much of a difference (IMHO).
Ordering/romanization/labels of languages differ. So providing a list to pick from in effect forces to pick from English terms for the languages, even if started in a locale where auto-selecting the language of the installer would work.

A localized dummy-installer (i.e. single-language, the one that was selected on the dl-page) that in turn calls the actual installer with some magic to select the language also isn't that nice, as it is an additional download or a "web installer" like thing that would need to download the real installer. This makes installing to multiple systems more complicated.
Comment 7 Sveinn í Felli 2014-08-05 13:32:06 UTC
Some additional info can be found in this thread:
<http://nabble.documentfoundation.org/libreoffice-l10n-Localisation-gone-wild-tt4042744.html#none>

Especially the post:  Mar 11, 2013; 9:37pm from Andras Timar. Seconded by post  Mar 12, 2013; 7:55am from Andras.

See also "Bug 50509 - Language selection is not possible with silent install", there are some useful pointers. 

So the matter is about MSI-packaging (and possibly a Windows bug)
Comment 8 Rimas Kudelis 2014-08-05 15:40:55 UTC
(In reply to comment #6)
> Listing languages to pick will also present the user with an English
> "greeting"/instructions to pick a language, so only helps partially, as a
> "shortcut" to the customized installation. So it could just tell to pick
> "custom install" and select the language(s) to install" right away without
> /that/ much of a difference (IMHO).

No, the dialog should be shown in the autodetected (system) locale. It could say something like "Please choose your preferred UI language. It will be used by the installer and installed with LibreOffice by default." The choice made there should change the installer language and alter the defaults at run-time, so that the user would NOT have to choose custom installation if they only care about that one language.

From my understanding, the current defaults are to install en-US and system locale. We could either replace "system locale" in this list with "chosen locale", or simply add "chosen locale" to it.

Of course, that's assuming this is all possible with MSI.
Comment 9 Urmas 2014-08-06 00:40:11 UTC
What's wrong with the current situation where the language preference of the system administrator and the system locale define the UI languages installed?
Comment 10 Michael Bauer 2014-08-06 09:32:46 UTC
At the risk of repeating myself: it removes user control over the UI language and it only caters well for monolingual speakers of really big languages. 

So if you're a German-only speaker on a German OS then you're dandy. 

If you're a Sorbian speaker in Germany on a German OS because there is no OS in your language or because you don't have the right hardware for the langpack for your language, you have a very frustrating experience of getting LO in the language you want. That applies to a LOT of potential users.

We also had the case where someone was working on a company PC which had Chinese as an OS language but he actually wanted it in English but because the installer 'assumed' wrongly, he ended up with it in Chinese and of course once you have installed LO (http://ask.libreoffice.org/en/question/9648/simplifying-the-setting-for-installation-language/), there is no way of *adding* a langpack via settings, you have to run the installer again and you still have to guess that you need to run Custom Install.

I end up putting in twice as much time promoting LO than, for example, VLC in my locale. With VLC I just have to describe the install process and then explain how to change the UI language in Settings. With LO I have to describe a really complex dance through Custom Install and I'm forever getting phonecalls and emails saying 'I installed LO because I heard from a friend its in Gaelic but it only comes up in English'. And not a single one, after I walk them through it, goes 'oh fair enough', they ALL go 'why is it this complicated to select your language?'

Other possibilities that we might contemplate: 

Allow download of langpack (like downloading addons from the addon site) if the user selects a language in Settings (after install) that was not installed.

Run some pre-installer. I don't know how it works but sometimes when the actual installer is really big, you get to download a much smaller file which walks you through some questions before it actually downloads the installation files. Or perhaps a first-run dialogue which offers the user to set the UI language and downloads if necessary?
Comment 11 Sveinn í Felli 2014-08-06 10:24:47 UTC
(In reply to comment #9)
> What's wrong with the current situation where the language preference of the
> system administrator and the system locale define the UI languages installed?

Well, there are several scenarios:

-When your locale is not well supported in the OS
-When you want LO to be in another language than imposed by the OS (think about foreign language teachers in schools, or translators)
-When you want to be able to fine-tune multi language environments

The reason for offering such possibilities in LO is plain politeness.
Comment 12 Urmas 2014-08-06 12:40:26 UTC
Normal people have to think about the language 1 (one) time only: on the Welcome screen of Windows install DVD. The installation process is intended to be simple for normal people. There is a *custom* installation option for fantastic scenarios affecting fractions of a percent you describe here.

Also, there are some attempts at disinformation here which I will address:

(1) LO can be easily installed with any UI language on the Chinese system;
(2) Gaelic language (LCID 0x043C) is trivial to be selected as the system locale; if LO doesn't use it, it is a bug.
Comment 13 Michael Bauer 2014-08-06 12:59:37 UTC
Not anymore. Windows *installs* only in about 6 languages these day, English, German, Chinese and a couple of others. Virtually *all* other languages from Win 7 onwards are handled by langpacks which the user has to install afterwards. Not that that's really relevant.

The problem with custom installation (which is NOT fantastic by the way) is that anyone not working on LO does not expect the language selection to be there. You have to know. Or spend hours googling the problem. Or call/email people like me who have to spend 20 (unpaid) minutes talking them through something that should be obvious during installation. Oh and having to apologize several times for it being so unintuitive.

And you completely ignore the fact that LO comes in more languages that you get OS in. Especially on Mac.
Comment 14 Rimas Kudelis 2014-08-07 07:17:52 UTC
(In reply to comment #12)
> Normal people have to think about the language 1 (one) time only: on the
> Welcome screen of Windows install DVD. 

This is not entirely true. While countries which constitute big markets almost always get new computers tailored for them (with the right keyboard layout printed, right languages available to choose during first run, right manuals printed and so on), smaller markets are not always privileged with such attention. In Lithuania, for example, you can (or at least could, a couple years ago) often find new laptops on the shelves, which are produced for Scandinavian market. Guess if the buyer can choose Lithuanian as the UI language in these. Of course not.

And for minority languages, to which Windows is not localized at all, the situation is even worse.
Comment 15 Mikeyy - L10n HR 2014-08-07 07:37:31 UTC
In Croatia it's common to have english Windows UI with croatian keyboard layout.
We have croatian language pack for Windows UI, but I guess people which install it don't like it translated...

For example my company laptop has that setup, and I didn't install Windows there.
This results in LibreOffice UI in english with localisation preferences in croatian.
I know how to change it, but I see a lot of people in company using LO in english since they don't even know they can change language which has automaticly been choosen.

Place language chooser on first page of install screen. There a load of exuses here why not to do it, but any choosing option on first page is better then none.
If you have language names translated, even if people don't understand question written in english (or whatever other language), they will eventualy figure it out when they see their language name in their language.

Maybe you can have 2 languages shown on same screen by default, windows UI language and keyboard language, and then rest of languages.

For example, this would be dropdown menu for my install on Windows 7, UI = English US, keyboard = Croatian HR:

English (US)
Hrvatski
--------------
Deutsch
English (UK)
English (US)
Francais
Hrvatski
Comment 16 Michael Bauer 2014-08-07 10:27:10 UTC
We're not just talking minority languages here either. There are many huge languages which are almost totally unsupported like Javanese (82 million speakers), Oromo (24m), Chichewa (12m), Sundanese (38m), Fula (25m)... it's a long list before you get to languages below 1m even.
Comment 17 Urmas 2014-08-11 13:35:05 UTC
User locale, system locale and windows UI language are different things.

> often find new laptops on the shelves, which are produced for Scandinavian 
> market. Guess if the buyer can choose Lithuanian as the UI language in these.

Why? If the administrator has selected Lithuanian locale (just for himself), LO will preselect Lithuanian UI no matter what Windows is localized in.
Comment 18 Michael Bauer 2014-08-11 13:48:51 UTC
Will you quit going on about Windows? LO is a cross-platform product so to begin with, we need to consider Win/Mac/Linux.

And you keep ignoring the point that there are many locales which just don't exist on at least one of them. The locales you're offered depend on the amount of weed the developer in question was smoking.

And you also keep ignoring the fact that most users haven't got a CLUE what a locale is or where to set it. Which means that although in the UK we have at least 7 locales (Scottish Gaelic, Irish, Manx, Cornish, Jerriais, Welsh and English UK), most systems are set to English UK because that's what the default was. Not that any OS (apart from Linux perhaps) even offers Jerriais or Cornish.
Comment 19 Mikeyy - L10n HR 2014-08-11 13:50:48 UTC
Not sure if that's same guy which was trolling on mailing lists, but I think he is trolling you right now. :)
Comment 20 Urmas 2014-08-11 23:15:46 UTC
> Will you quit going on about Windows?

This bug is about Windows-only MSI installer.

And you keep ignoring the point that there are many locales which just don't exist on at least one of them. The locales you're offered depend on the amount of weed the developer in question was smoking.

> Not that any OS (apart from Linux perhaps) even offers Jerriais or Cornish.

And the last thing they need is LO in Jerriais.

You are trying to inconvenience EVERYONE using English, Spanish or Russian language software so some Cornish ultranationalist would be spared 3 mouseclicks?
Are you serious?
Comment 21 Michael Bauer 2014-08-11 23:39:26 UTC
Urmas, I will ignore anything you say from now on. Fortunately I've been around LO long enough to know that your extremist view is not generally held. Good luck with all that hate.
Comment 22 QA Administrators 2016-09-20 10:17:50 UTC Comment hidden (obsolete)
Comment 23 Michael Bauer 2016-09-20 10:40:17 UTC
It's still an issue
Comment 24 Xisco Faulí 2017-09-29 08:48:29 UTC Comment hidden (obsolete)
Comment 25 Michael Bauer 2017-09-29 09:37:30 UTC
It's still an issue. I'm really surprised it still is though, as this represents an unnecessarily high barrier to new low-tech users.
Comment 26 QA Administrators 2018-09-30 02:48:33 UTC Comment hidden (obsolete)
Comment 27 Michael Bauer 2018-10-01 13:55:28 UTC
Did a complete uninstall of LibreOffice, went to the website, specifyied Scots Gaelic, downloaded 6.1.2, ran the default install, boom, English. Had to go to Modify to get Gaelic after installation.

Windows 10 with the Scots Gaelic langpack installed and set to default. So it's not even picking up on the system locale.

So yes, this issue persists.
Comment 28 Mike Kaganski 2019-04-11 21:22:19 UTC
Some technical details:

1. Installer UI language (on Windows; the bug is about MSI) depends not on OS language, but on the language set at "Region and Language" -> "Format" (accessible using intl.cpl command line). That is per-user setting. One might set the language there once, and if required, change all settings there manually to have, e.g., Croatian language + en_UK decimal separator settings.
2. Creating an additional installer screen (or better re-using existing "Welcome to the installation Wizard" screen) to place language selector (along with the text like "you may select the language of LibreOffice UI to install here - which is a shortcut for UI selection available under Advanced") is possible; feel free to jump in and make it happen. Personally I could provide you with advises; however, that's not an easy hack in my view.
3. However, selecting the language there *can not* change installer UI. This is limitation of MSI technology; and the only workaround is some bootstrap application mentioned in comment 6. Creating such bootstrap would be another, even bigger task. To choose installer UI language without changing Language -> Format, one may use ProductLanguage property with *decimal* [MS-LCID] value for any language supported by installer and OS (shown en_US; note that link below lists LCIDs in hexadecimal):

> msiexec /i LibreOffice_X.Y.Z_Win_x64.msi ProductLanguage=1033

[MS-LCID] https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-lcid/a9eac961-e77d-41a6-90a5-ce1a8b0cdb9c
Comment 29 Michael Bauer 2019-04-11 22:18:32 UTC
>1. Installer UI language (on Windows; the bug is about MSI) depends not on OS language, but on the language set at "Region and Language" -> "Format" 

Clearly it doesn't because Gaelic is set as the language in Region and Language too.
Comment 30 Mike Kaganski 2019-04-11 22:55:36 UTC
(In reply to Michael Bauer from comment #29)

It does. If for your language, it  doesn't happen, that is a bug, which you are advised to file separately, stating the specific settings that don't end up with a desired result.
Comment 31 Mike Kaganski 2019-04-11 23:21:48 UTC
FTR: here is the list of LO *installer* UI language codes (from MSI summary information), along with their meaning as per [MS-LCID]:

> 1033	English (United States)
> 1078	Afrikaans (South Africa)
> 1118	Amharic (Ethiopia)
> 1025	Arabic (Saudi Arabia)
> 1101	Assamese (India)
> 1610	#N/A
> 1059	Belarusian (Belarus)
> 1026	Bulgarian (Bulgaria)
> 2117	Bangla (Bangladesh)
> 1093	Bangla (India)
> 2121	Tamil (Sri Lanka)
> 1150	Breton (France)
> 1603	#N/A
> 5146	Bosnian (Latin) (Bosnia and Herzegovina)
> 1027	Catalan (Spain)
> 2051	Valencian (Spain)
> 1029	Czech (Czech Republic)
> 1106	Welsh (United Kingdom)
> 1030	Danish (Denmark)
> 1031	German (Germany)
> 1604	#N/A
> 3153	Dzongkha (Bhutan)
> 1032	Greek (Greece)
> 2057	English (United Kingdom)
> 7177	English (South Africa)
> 1553	#N/A
> 1034	Spanish (Spain)
> 1061	Estonian (Estonia)
> 1069	Basque (Spain)
> 1065	Persian (Iran)
> 1035	Finnish (Finland)
> 1036	French (France)
> 1122	Frisian (Netherlands)
> 2108	Irish (Ireland)
> 1084	#N/A
> 1110	Galician (Spain)
> 1095	Gujarati (India)
> 1140	Guarani (Paraguay)
> 1037	Hebrew (Israel)
> 1070	Upper Sorbian (Germany)
> 1081	Hindi (India)
> 1050	Croatian (Croatia)
> 1038	Hungarian (Hungary)
> 1057	Indonesian (Indonesia)
> 1039	Icelandic (Iceland)
> 1040	Italian (Italy)
> 1041	Japanese (Japan)
> 1079	Georgian (Georgia)
> 1625	#N/A
> 1087	Kazakh (Kazakhstan)
> 1107	Khmer (Cambodia)
> 1574	#N/A
> 1099	Kannada (India)
> 1042	Korean (Korea)
> 1111	Konkani (India)
> 1120	Kashmiri (Perso-Arabic)
> 1134	Luxembourgish (Luxembourg)
> 1108	Lao (Lao P.D.R.)
> 1063	Lithuanian (Lithuania)
> 1062	Latvian (Latvia)
> 1605	#N/A
> 1071	Macedonian (North Macedonia)
> 1100	Malayalam (India)
> 1104	Mongolian (Cyrillic) (Mongolia)
> 1112	#N/A
> 1102	Marathi (India)
> 1109	Burmese (Myanmar)
> 1044	Norwegian (Bokmal) (Norway)
> 1121	Nepali (Nepal)
> 1043	Dutch (Netherlands)
> 2068	Norwegian (Nynorsk) (Norway)
> 1580	#N/A
> 1132	Sesotho sa Leboa (South Africa)
> 1154	Occitan (France)
> 2162	#N/A
> 1096	Odia (India)
> 1094	Punjabi (India)
> 1045	Polish (Poland)
> 2070	Portuguese (Portugal)
> 1046	Portuguese (Brazil)
> 1048	Romanian (Romania)
> 1049	Russian (Russia)
> 1569	#N/A
> 1103	Sanskrit (India)
> 1606	#N/A
> 1113	#N/A
> 2074	Serbian (Latin) (Serbia and Montenegro (Former))
> 2133	#N/A
> 1669	#N/A
> 1051	Slovak (Slovakia)
> 1060	Slovenian (Slovenia)
> 1052	Albanian (Albania)
> 3098	Serbian (Cyrillic) (Serbia and Montenegro (Former))
> 1579	#N/A
> 1072	Sotho (South Africa)
> 1053	Swedish (Sweden)
> 1089	Kiswahili (Kenya)
> 1097	Tamil (India)
> 1098	Telugu (India)
> 1064	Tajik (Cyrillic) (Tajikistan)
> 1054	Thai (Thailand)
> 1074	Setswana (South Africa)
> 1055	Turkish (Turkey)
> 1073	Tsonga (South Africa)
> 1092	Tatar (Russia)
> 1152	Uyghur (People's Republic of China)
> 1058	Ukrainian (Ukraine)
> 1091	Uzbek (Latin) (Uzbekistan)
> 1075	Venda (South Africa)
> 1685	#N/A
> 1066	Vietnamese (Vietnam)
> 1076	Xhosa (South Africa)
> 2052	Chinese (Simplified) (People's Republic of China)
> 3076	Chinese (Traditional) (Hong Kong S.A.R.)
> 5124	Chinese (Traditional) (Macao S.A.R.)
> 1028	Chinese (Traditional) (Taiwan)
> 1077	Zulu (South Africa)

It seems that there's no Gaelic there; or one of the "#N/A" codes might (wrongly?) be used for Gaelic, thus preventing proper identification.

In former case, it's not a bug, but just a missing localization of installer (volunteer translators are always welcome). In the latter, in case a proper bug report appears, it might be fixed.
Comment 32 Eike Rathke 2019-04-24 15:53:06 UTC
The 1084 case was Gaelic (Scotland) gd-GB, see bug 124791.

The other #N/A cases almost all are/were user defined LCIDs MS doesn't/didn't have LCIDs for the language/locale:

1610 ast-ES Asturian
1603 brx-IN Bodo
1604 dgo-IN Dogri
1553 eo Esperanto
1625 kab-DZ Kabyle <<< should now be 2143 (0x085F)
1574 kmr-Latn-TR
1605 mai-IN Maithili
1112 mni-IN Manipuri <<< MS lists it (0x0458) as reserved for mni-IN
1580 nr-ZA Ndebele, South
2162 <<< there is no such thing, we don't define it and MS doesn't either, but it's wrongly used (since f586a64f8fcae5d342bf3323bb367b9b048de384) for om-ET Oromo, which is 1138 (0x0472)
1569 rw-RW Kinyarwanda <<< should now be 1159 (0x0487)
1606 sat-IN Santali
1113 sd-Deva-IN Sindhi, Devanagari <<< MS lists it (0x0459) as reserved for sd-Deva-IN
2133 <<< there is no such thing, we don't define it and MS doesn't either, but it's wrongly used (since f586a64f8fcae5d342bf3323bb367b9b048de384) for si-LK Sinhala, which should be 1115 (0x045B)
1669 sid-ET Sidama
1579 ss-ZA Swazi
1685 vec-IT Venetian

So, altogether there are four that need to be changed in l10ntools/source/ulfconv/msi-encodinglist.txt

kab 0 1625 <<< should now be 2143
rw 0 1569 <<< should now be 1159
om 0 2162 <<< should be 1138
si 0 2133 <<< should be 1115
Comment 33 Eike Rathke 2019-04-24 16:05:08 UTC
@MikeKaganski:
Would be appreciated if you could test MSI with https://gerrit.libreoffice.org/71247
Thanks.
Comment 34 Commit Notification 2019-04-29 17:40:51 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/0dcbc797a6cf7dc58ad17aae20bf0ccc7973cab1%5E%21

Related: tdf#82184 correct wrong or obsoleted LCIDs for MSI

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 35 Commit Notification 2019-04-30 00:45:41 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "libreoffice-6-2":

https://git.libreoffice.org/core/+/8d8a759da7ca6d2ae9aa53986d40cbbd106ffb86%5E%21

Related: tdf#82184 correct wrong or obsoleted LCIDs for MSI

It will be available in 6.2.4.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.